<template>
  <div>
    <v-switch
      prepend-icon="mdi-cursor-move"
      label="Reordenar"
      v-model="sortable"
      v-if="fileRecords.length > 0"
    >
    </v-switch>
    <vue-file-agent
      :multiple="true"
      :deletable="deleteable"
      :editable="false"
      :meta="true"
      :maxSize="'15MB'"
      :theme="'list'"
      :accept="
        'application/pdf, .doc, .docm, .docx, .dotx, .xlsx, .xlsb, .xls, xlsm, .ppt, .pptm, .pptx, .ppsm'
      "
      :maxFiles="25"
      :auto="false"
      :linkable="false"
      class="upload-block"
      :readonly="readonly"
      :sortable="sortable"
      :helpText="'Arrastra tu archivo aquí o selecciónalo aquí'"
      :errorText="{
        type: 'Formato del archivo no permitido',
        size: 'Los archivos no pueden pasar mas de 15MB',
      }"
      :class="{ 'error-validation': data.validator.$error }"
      @select="filesSelected($event)"
      @beforedelete="onBeforeDelete($event)"
      @delete="fileDeleted($event)"
      @sort="onSort($event)"
      @upload="onUpload($event)"
      @upload:error="onUploadError($event)"
      @upload:delete="onUploadDelete($event)"
      @upload:delete:error="onUploadDeleteError($event)"
      ref="vueFileAgent"
      v-model="fileRecords"
    >
      <template v-slot:file-preview="slotProps">
        <VueFilePreview
          :key="'ee' + slotProps.index"
          :value="slotProps.fileRecord"
          :deletable="deleteable"
          :linkable="true"
          class="file-preview-wrapper grid-box-item grid-block"
        ></VueFilePreview>
        <div class="actions">
          <v-chip color="white" :elevation="0" light fab x-small class="indice">
            {{ slotProps.index + 1 }}
          </v-chip>
          <v-btn
            v-if="deleteable"
            color="red"
            light
            tile
            x-small
            class="ma-0 pa-0 white--text delete"
            @click="removeFileRecord(slotProps.fileRecord)"
          >
            <v-icon small>mdi-delete</v-icon>
          </v-btn>
        </div>
      </template>
    </vue-file-agent>
  </div>
</template>
<style>
.actions {
  position: absolute;
  top: 0px;
  bottom: 0px;
  left: 0px;
  right: 0px;
}
.indice {
  z-index: 11;
  top: 4px;
  left: 13px;
  position: absolute;
  height: 11px !important;
}
.delete {
  z-index: 11;
  float: right;
}
.is-sortable-enabled.is-sortable-immediately
  .file-preview-wrapper.grid-box-item.grid-block:not(.file-preview-new) {
  border: 2px dashed #ffcd00;
  margin-top: 4px !important;
}
.is-sortable-enabled.is-sortable-immediately
  .file-preview-wrapper.grid-box-item.grid-block.file-preview-new {
  display: none;
}
.error-validation .vue-file-agent.file-input-wrapper {
  border: 2px dashed rgb(253, 81, 81);
}
.grid-block-wrapper.vue-file-agent.file-input-wrapper {
  z-index: 0;
}
</style>
<script>
import store from "@/store";
const axios = store.state.axiosApiLocal;
const serviceLocalStorage = store.state.serviceLocalStorage;
const fileExample = {
  uid: "67654476",
  name: "Archivo.pdf",
  size: 1024,
  type: "application/pdf",
  ext: "pdf",
  url: "https://safrazik.com/vue-file-agent/website/assets/files/sample.pdf",
};
export default {
  name: "Component-Archivos",
  props: ["value", "folio", "type"],
  data: () => ({
    sortable: false,
    deleteable: true,
    readonly: false,
    fileRecordToDelete: null,
    fileRecords: [],
    uploadHeaders: {
      "Content-Type": "application/json",
      Authorization: "Bearer " + serviceLocalStorage.getAccessToken(),
    },
    fileRecordsForUpload: [],
  }),
  watch: {
    fileRecords(val, prev) {
      this.data.value = val;
    },
    sortable(val, prev) {
      this.readonly = val;
      this.deleteable = !val;
    },
  },
  computed: {
    uploadUrl() {
      let value =
        store.state.urlApiPlataformaFranquicia +
        "modelo-negocio/folio-archivos/v1/" +
        this.folio.idFolio +
        "/archivos";
      return value;
    },
    data: {
      get() {
        return this.value;
      },
      set(value) {
        this.$emit("input", value);
      },
    },
  },
  methods: {
    removeFileRecord: function(fileRecord) {
      return this.$refs.vueFileAgent.removeFileRecord(fileRecord);
    },
    toBase64(file) {
      return new Promise((resolve, reject) => {
        const reader = new FileReader();
        reader.readAsDataURL(file);
        reader.onload = () => resolve(reader.result);
        reader.onerror = (error) => reject(error);
      });
    },
    onUpload(responses) {
      for (let response of responses) {
        if (response.error) {
          continue;
        }
        let data = response.data;
        if (data) {
          let uid = data.resultado.uid;
          response.fileRecord.uid = uid;
          response.fileRecord.url = this.uploadUrl + "/" + uid + "/contenido";
          this.postArchivoVirtual(response.fileRecord);
        }
      }
    },
    onUploadError(failedResponses) {
      for (let failedResponse of failedResponses) {
        failedResponse.fileRecord.upload.error = "Error Inesperado...!";
      }
    },
    uploadFiles() {
      if (this.fileRecordsForUpload.length > 0) {
        this.$refs.vueFileAgent.upload(
          this.uploadUrl,
          this.uploadHeaders,
          this.fileRecordsForUpload,
          function createFormData(fileData) {
            let srcB64 = fileData.raw.srcB64;
            srcB64 = srcB64.split(",")[1];
            return (
              '{"nombre":"' +
              fileData.file.name +
              '","archivo":"' +
              srcB64 +
              '", "tipoContenido": "' +
              fileData.file.type +
              '"}'
            );
          }
        );
        this.fileRecordsForUpload = [];
      }
    },
    async filesSelected(fileRecordsNewlySelected) {
      for (let fileRecordNewlySelected of fileRecordsNewlySelected) {
        const result = await this.toBase64(
          fileRecordNewlySelected.file
        ).catch((e) => Error(e));
        if (result instanceof Error) {
          console.log("Error: ", result.message);
          return;
        }
        fileRecordNewlySelected.srcB64 = result;
        fileRecordNewlySelected.indice = this.fileRecords.length;
      }
      var validFileRecords = fileRecordsNewlySelected.filter(
        (fileRecord) => !fileRecord.error
      );
      this.fileRecordsForUpload = this.fileRecordsForUpload.concat(
        validFileRecords
      );
      this.uploadFiles();
    },
    onRemove(event, fileRecord) {
      this.onBeforeDelete(fileRecord.raw);
    },
    onBeforeDelete: function(fileRecord) {
      this.fileRecordToDelete = fileRecord;
      var i = this.fileRecordsForUpload.indexOf(fileRecord);
      if (i !== -1) {
        this.fileRecordsForUpload.splice(i, 1);
        var k = this.fileRecords.indexOf(fileRecord);
        if (k !== -1) this.fileRecords.splice(k, 1);
      } else {
        if (fileRecord.uid) {
          if (confirm("Estas seguro de eliminar el archivo...?")) {
            this.$refs.vueFileAgent.deleteFileRecord(fileRecord); // will trigger 'delete' event
          }
        } else {
          this.$refs.vueFileAgent.deleteFileRecord(fileRecord);
        }
      }
    },
    deleteUploadedFile: function(fileRecord) {
      this.$refs.vueFileAgent.deleteUpload(
        this.uploadUrl + "/" + fileRecord.uid,
        this.uploadHeaders,
        fileRecord,
        function createFormData(fileData) {
          return "";
        }
      );
    },
    fileDeleted: function(fileRecord) {
      var i = this.fileRecordsForUpload.indexOf(fileRecord);
      if (i !== -1) {
        this.fileRecordsForUpload.splice(i, 1);
      } else {
        this.deleteUploadedFile(fileRecord);
      }
    },
    onUploadDelete(response) {
      this.deleteArchivoVirtual(response.fileRecord);
    },
    onUploadDeleteError(event) {
      if (this.fileRecordToDelete.uid) {
        this.fileRecords.push(this.fileRecordToDelete);
      }
    },
    onSort(event) {
      alert(1);
      console.log(event);
      let fileRecordOld = this.fileRecords[event.oldIndex];
      let fileRecordNew = this.fileRecords[event.newIndex];
      fileRecordNew.indice = event.newIndex;
      fileRecordOld.indice = event.oldIndex;
      this.putArchivoVirtual(fileRecordNew);
      this.putArchivoVirtual(fileRecordOld);
    },
    getFolioArchivosVirtuales() {
      const self = this;
      axios(
        "/modelo-negocio/folio-virtuales-archivos/v1/" +
          this.folio.idFolio +
          "/virtuales/archivos"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            data.resultado.folioVirtualesArchivos.forEach((itemArchivo) => {
              itemArchivo.type = itemArchivo.tipoContenido;
              itemArchivo.ext = itemArchivo.extension;
              itemArchivo.size = itemArchivo.peso;
              itemArchivo.name = itemArchivo.nombre;
              delete itemArchivo.nombre;
              delete itemArchivo.peso;
              delete itemArchivo.extension;
              delete itemArchivo.tipoContenido;
              delete itemArchivo.descripcion;
              if (itemArchivo.tipo == this.type) {
                self.fileRecords.push(itemArchivo);
              }
            });
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        })
        .finally(() => {
          this.$emit("loaded", true);
        });
    },
    postArchivoVirtual(file) {
      const body = {
        uid: file.uid,
        nombre: file.name(),
        descripcion: file.name(),
        peso: file.size,
        extension: file.ext,
        tipo: this.type,
        tipoContenido: file.type,
        indice: file.indice,
      };
      const self = this;
      axios
        .post(
          "/modelo-negocio/folio-virtuales-archivos/v1/" +
            this.folio.idFolio +
            "/virtuales/archivos",
          body
        )
        .then((response) => {
          let data = response.data;
          if (data) {
            file.idArchivo = data.resultado.id;
            let temp = JSON.parse(JSON.stringify(self.data.value));
            self.data.value = temp;
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    putArchivoVirtual(file) {
      const body = {
        uid: file.uid,
        nombre: file.name(),
        descripcion: file.name(),
        peso: file.size,
        extension: file.ext,
        tipo: this.type,
        tipoContenido: file.type,
        indice: file.indice,
      };
      axios
        .put(
          "/modelo-negocio/folio-virtuales-archivos/v1/" +
            this.folio.idFolio +
            "/virtuales/archivos/" +
            file.idArchivo,
          body
        )
        .then((response) => {})
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    deleteArchivoVirtual(file) {
      axios
        .delete(
          "/modelo-negocio/folio-virtuales-archivos/v1/" +
            this.folio.idFolio +
            "/virtuales/archivos/" +
            file.idArchivo
        )
        .then((response) => {})
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
  },
  created() {
    this.getFolioArchivosVirtuales();
    this.data.value = this.fileRecords;
  },
};
</script>
